#!/usr/bin/perl -w

$lmjpeg="../optimized/src/lmjpeg";
$workdir="/mnt/wind/upload/test";
$outputdir="$workdir/out";
$stats="output_xvid.csv";
$keepfiles=100;	# only keep files smaller _ MB
$start=1;

@infiles=("mm-260505_tscc_1000.avi","ac10_30s.avi","heute_huff_46s.avi","terminal_t60_640_huff.avi");
@quant=(1,2,4,6,8,12,18,24,31);
@keyf=(100000,50,100,200);

$number=1;
$enc_times=($#infiles+1)*($#quant+1)*($#keyf+1);
print "there will be ".$enc_times." encodings\n";
open OUTPUT,">$stats" or print "Error opening output file!\n";
printf(OUTPUT "#Number,Input name,Output name,Quantizer,Compression,Size in KB,Encoding time,Total time,Command\n");

sub startlmjpeg_xvid {
	$in=shift;
	$quant=shift;
	$keyf=shift;

	$out=sprintf("%s/%s_xvid_%04s_%03s.avi",$outputdir,$in,$quant,$keyf);
	#$cmd="$lmjpeg xvid -bitrate $bitrate -keyframe $keyf write $workdir/$in $out";
	
	$cmd="mencoder $workdir/$in -o $out -nosound -ovc xvid -xvidencopts fixed_quant=$quant:max_key_interval=$keyf:notrellis:quant_type=mpeg:nolumi_mask:quant_inter_matrix=/home/benjamin/intra:quant_intra_matrix=/home/benjamin/intra:max_bframes=0";
	#$cmd="transcode -i $workdir/$in -x ffbin,null -o $out -y xvid4,null --config_dir ~/ -R 3 -w $quant,$keyf";

	# exec and just print time
	system $cmd;
	$enctime=1;
	$extime=1;

	if (-e "$out") {$size=-s "$out";}
	else {$size=0;}
	printf(OUTPUT "%s,%s,%s,%s,%s,%s,%s,%s,%s\n",$number,$in,$out,$quant,$keyf,$size/1024,$enctime,$extime,$cmd);
	
	print "*** done: $number time: $extime encodings left: ".($enc_times-$number);
	$sec=int((($enc_times-$number)*$extime)%60);
	$min=int(((($enc_times-$number)*$extime)/60)%60);
	$hrs=int((($enc_times-$number)*$extime)/3600);
	printf(" expected time left: %s:%02s:%02s",$hrs,$min,$sec);
	$sec=int(($enc_times*$extime)%60);
	$min=int((($enc_times*$extime)/60)%60);
	$hrs=int(($enc_times*$extime)/3600);
	printf(" expected total time: %s:%02s:%02s ***\n",$hrs,$min,$sec);
	print `df -h $out`;
	if ($size/(1024*1024) > $keepfiles) {system "rm $out";}
	sleep(1);
}

for ($i1=0;$i1<=$#infiles;$i1++) {
	for ($i4=0;$i4<=$#quant;$i4++) {
		for ($i5=0;$i5<=$#keyf;$i5++) {
			if ($number >= $start) {
				startlmjpeg_xvid($infiles[$i1],$quant[$i4],$keyf[$i5]);
			}
			$number++;
		}
	}
}

close OUTPUT;
